#include <hFramework.h>
#include <Lego_Touch.h>
#include <Lego_Ultrasonic.h>
#include <hExt.h>
#include <stdio.h>
#include <stdlib.h>
using namespace hFramework;
using namespace hSensors;
Lego_Touch sensor1(hSens1); //czujnik sprawdzania czy brama jest otwarta
Lego_Touch sensor2(hSens3); //czujnik przeszkody
Lego_Ultrasonic sensor(hSens2); //czujnik odleglosci
char i; //stan przyciku z aplikacji
bool state1;
bool state2;
bool stateH1;
bool stateH2;
int dist;
int dl=30; //szybkosc otwierania/zamykania
int k=240; //liczba krokow
int a; //licznik
int b; //drugi licznik
int c=0;
int d=0;
int mo=900; //moc silnika przy otwieraniu
int mz=500; //moc silnika przy zamykaniu
void hMain(void)
{
	hExt1.serial.init(9600, Parity::Odd, StopBits::Two);
	for (b=0; b<k; b++)
	{
		state1=sensor1.isPressed();
		if (state1)
		{
			hMot1.rotRel(-10);
			b=240;
			d=240;
		}
		else
		{
			hMot1.rotRel(4, mo);
			sys.delay(dl);
		}
	}
	while(true)
	{
		state1=sensor1.isPressed();
		stateH2=hBtn2.isPressed();
        stateH1=hBtn1.isPressed();
		i='x';
		if (hExt1.serial.available() > 0)
		{i=hExt1.serial.getch();}
		else
		{}
		if (state1 && (stateH2 || i=='d') && d==240) //komenda zamykania
		{
			for (a=0; a<k; a++)
			{
				LED1.on();
				state1=sensor1.isPressed();
				state2=sensor2.isPressed();
				dist=sensor.readDist();
				stateH1=hBtn1.isPressed();
				stateH2=hBtn2.isPressed();
				if (hExt1.serial.available() > 0)
				{i=hExt1.serial.getch();}
				if (!state1 && dist >20 && (stateH1 || i=='g')) //zatrzymanie
				{
					hMot1.setPower(0);
					c=240-a;
					a=k;
					sys.delay(1000);
				}
				else if (!state2 && dist>20) //zamykanie
				{
					hMot1.rotRel(-4, mz);
					c=0;
				}
				else if ((state2 || dist<21) && !stateH1 && !stateH2 ) //otwieranie po napotkaniu przeszkody
				{
					for(int b=0; b<a; b++)
		            {
			            hMot1.rotRel(4, mo);
						sys.delay(dl);
		            }
					c=240;
                    a=k;
				}
				sys.delay(dl);
				LED1.off();
			}
			d=c;
		}
		else if (!state1 && (stateH1 || i=='g') && d==0) //komenda otwierania
		{
			for (a=0; a<k+20; a++)
			{
				if (hExt1.serial.available() > 0)
				{i=hExt1.serial.getch();}
				state1=sensor1.isPressed();
				stateH2=hBtn2.isPressed();
				if (state1) // koniec otwierania (brama jest otwarta)
				{
					hMot1.setPower(0);
					a=260;
					c=240;
				}
				else if (!state1 && (stateH2 || i=='d')) // zatrzymanie
				{
					hMot1.setPower(0);
					sys.delay(1000);
					c=a;
					a=k+260;
				}
				else if (!state1) // otwieranie
				{
				hMot1.rotRel(4, mo);
				LED3.on();
				sys.delay(dl);
				c=a;
				}
			}
			d=c;
			LED3.off();
		}
		else if (!state1 && (stateH1 || i=='g') && d>0) //komenda otwierania z dowolnej pozycji
		{
			for (a=0; a<k+20; a++)
			{
				if (hExt1.serial.available() > 0)
				{i=hExt1.serial.getch();}
				state1=sensor1.isPressed();
				stateH2=hBtn2.isPressed();
				if (state1) // koniec otwierania (brama jest otwarta)
				{
					hMot1.setPower(0);
					a=260;
					c=240;
				}
				else if (!state1 && (stateH2 || i=='d')) // zatrzymanie
				{
					hMot1.setPower(0);
					sys.delay(1000);
					c=a;
					a=k+20;
				}
				else if (!state1) // otwieranie
				{
				hMot1.rotRel(4, mo);
				LED3.on();
				sys.delay(dl);
				c=a;
				}
			}
			d=c;
			LED3.off();
		}
		else if (!state1 && (stateH2 || i=='d') && d>0) //komenda zamykania z dowolnej pozycji
		{
			for (a=0; a<d; a++)
			{
				LED1.on();
				state1=sensor1.isPressed();
				state2=sensor2.isPressed();
				dist=sensor.readDist();
				stateH1=hBtn1.isPressed();
				stateH2=hBtn2.isPressed();
				if (hExt1.serial.available() > 0)
				{i=hExt1.serial.getch();}
				if (!state1 && dist >20 && (stateH1 || i=='g')) //zatrzymanie
				{
					hMot1.setPower(0);
					c=d-a;
					a=k;
					sys.delay(1000);
				}
				else if (!state2 && dist>20) //zamykanie
				{
					hMot1.rotRel(-4, mz);
					c=d-a;
				}
				else if ((state2 || dist<21) && !stateH1 && !stateH2 ) //otwieranie po napotkaniu przeszkody
				{
					for(int b=0; b<240-d+a; b++)
		            {
			            hMot1.rotRel(4, mo);
						sys.delay(dl);
		            }
					c=240;
                    a=k;
				}
				sys.delay(dl);
				LED1.off();
			}
			d=c;
		}
	}
}